features = cell(1,2);

for r = 1:2
    for x=1:2
        features{r}.sample{x}.local{1}.NumStates = 2;
        features{r}.sample{x}.local{2}.NumStates = 2;
        
        features{r}.sample{x}.local{1}.pot = [1.0;2.0];
        features{r}.sample{x}.local{2}.pot = [2.0;1.0];
        
        features{r}.sample{x}.local{1}.connTo = 3;
        features{r}.sample{x}.local{2}.connTo = 3;
        
        features{r}.sample{x}.factor{3}.pot = [1.0 0.0;0.0 1.0];
        features{r}.sample{x}.factor{3}.size = [2 2];
    end
end

for x=1:2
    loss.sample{x}.local{1}.NumStates = 2;
    loss.sample{x}.local{2}.NumStates = 2;
    
    loss.sample{x}.local{1}.pot = [0.0;1.0];
    loss.sample{x}.local{2}.pot = [1.0;0.0];
    
    loss.sample{x}.local{1}.connTo = 3;
    loss.sample{x}.local{2}.connTo = 3;
    
    loss.sample{x}.factor{3}.pot = [0.0 0.0;0.0 0.0];
    loss.sample{x}.factor{3}.size = [2 2];
end

d = [2.0;1.0];
p = 2;
C = 1;
epsilon = 1;
rGap = 1e-5;
it = 10;
th_init = [1.0;1.0];

theta = libCRFmatlab(features, loss, th_init, epsilon, 1, d, p, C, rGap, it);   %learning
pred = libCRFmatlab(features, [], theta, 0, 0); %prediction with CRF internal convex BP
libCRFmatlab(features, [], theta, 0, 0, [], [], [], [], [], '/home-nfs/aschwing/tmpHCRF/libHCRF/');    %writing UAI files (adapt directory)

